import React from 'react';
import type { SyntaxHighlighterProps } from 'react-syntax-highlighter';
export type CodeSnippetProps = {
    /**
     * the code string to show and to be copied to clipboard
     */
    children: string;
    /**
     * a class to override the highlighter class
     */
    frameClass?: string;
    /**
     * the theme to be used in the highlighter
     */
    theme?: any;
    /**
     * listen to mouse up event on the code snippet
     */
    onMouseUp?: (e: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
} & SyntaxHighlighterProps;
/**
 * A code snippet component
 */
export declare function CodeSnippet({ className, frameClass, theme, language, children, onMouseUp, ...rest }: CodeSnippetProps): import("react/jsx-runtime").JSX.Element;
